--  * 600 000 000

CREATE OR REPLACE PROCEDURE SFIX5 IS
	CURSOR UTABLES IS SELECT TABLE_NAME FROM USER_TABLES;
	I NUMBER;ROWCOUNT NUMBER;
	MAX_SYSKEY NUMBER;
	TBNAME VARCHAR2(30);SEQNAME VARCHAR2(30);
	CURS INTEGER;RET INTEGER;
	SQLSEQ VARCHAR2(128);
BEGIN
	OPEN UTABLES;
	LOOP
	  -- LOOP ALL TABLES
	  FETCH UTABLES INTO TBNAME;
	  EXIT WHEN UTABLES%NOTFOUND;
	  IF TBNAME<>'GRAPHLINESTYLE' and TBNAME<>'TRASSAIZOL' and SUBSTR(TBNAME,1,5)<>'SNAP$' and SUBSTR(TBNAME,1,5)<>'MLOG$' THEN
		SEQNAME:=RTRIM(TBNAME) || '_SEQ';
		-- DROP SEQUENCE
		CURS:=DBMS_SQL.OPEN_CURSOR;
		BEGIN
		  DBMS_SQL.PARSE(CURS,'DROP SEQUENCE ' || SEQNAME,DBMS_SQL.V7);
		  RET:=DBMS_SQL.EXECUTE(CURS);
		  RET:=1;
		EXCEPTION
		WHEN OTHERS THEN
		  RET:=0;
		END;
		DBMS_SQL.CLOSE_CURSOR(CURS);
		-- NUMBER OF ROWS IN TABLE INTO ROWCOUNT
		CURS:=DBMS_SQL.OPEN_CURSOR;
		DBMS_SQL.PARSE(CURS,'SELECT COUNT(*) AS ROWCOUNT FROM ' || TBNAME,DBMS_SQL.V7);
		DBMS_SQL.DEFINE_COLUMN(CURS,1,ROWCOUNT);
		RET:=DBMS_SQL.EXECUTE(CURS);
		RET:=DBMS_SQL.FETCH_ROWS(CURS);
		DBMS_SQL.COLUMN_VALUE(CURS,1,ROWCOUNT);
		DBMS_SQL.CLOSE_CURSOR(CURS);
		IF ROWCOUNT>0 THEN
			-- SELECT MAX(SYSKEY) INTO MAX_SYSKEY FROM TBNAME;
			CURS:=DBMS_SQL.OPEN_CURSOR;
			BEGIN
			  DBMS_SQL.PARSE(CURS,'SELECT MAX(SYSKEY) AS MAX_SYSKEY FROM ' || TBNAME,DBMS_SQL.V7);
			  DBMS_SQL.DEFINE_COLUMN(CURS,1,MAX_SYSKEY);
			  RET:=DBMS_SQL.EXECUTE(CURS);
			  RET:=DBMS_SQL.FETCH_ROWS(CURS);
			  DBMS_SQL.COLUMN_VALUE(CURS,1,MAX_SYSKEY);
			EXCEPTION
			WHEN OTHERS THEN
			  DBMS_OUTPUT.PUT_LINE('-- ' || TBNAME || ' NO SYSKEY');
			END;
			DBMS_SQL.CLOSE_CURSOR(CURS);
--			MAX_SYSKEY:=MAX_SYSKEY+1;
-- ***
			MAX_SYSKEY:=600000000+1;
-- ***
         IF MAX_SYSKEY<0 THEN
           MAX_SYSKEY:=1;
         END IF;
		ELSE
			MAX_SYSKEY:=1;
		END IF;
		IF TBNAME='AOMH' THEN
			MAX_SYSKEY:=13;
		END IF;
		-- CREATE SEQUENCE
		SQLSEQ:='CREATE SEQUENCE ' || SEQNAME || ' START WITH ' || TO_CHAR(MAX_SYSKEY) || ' INCREMENT BY 1 ORDER NOCACHE';
		DBMS_OUTPUT.PUT_LINE(SQLSEQ || ';');
		CURS:=DBMS_SQL.OPEN_CURSOR;
		DBMS_SQL.PARSE(CURS,SQLSEQ,DBMS_SQL.V7);
		RET:=DBMS_SQL.EXECUTE(CURS);
		DBMS_SQL.CLOSE_CURSOR(CURS);
	  END IF;
	END LOOP;  -- ALL TABLES
EXCEPTION
	WHEN OTHERS THEN
		IF DBMS_SQL.IS_OPEN(CURS) THEN
			DBMS_SQL.CLOSE_CURSOR(CURS);
		END IF;
-- ***
		raise_application_error(-20000,SEQNAME);
--		RAISE;
END;
/